/*
 * imagebuf.h
 *
 *  Created on: 2013/04/29
 *  Copyright(C) 2013 Ryoichi Yokomizu
 *  All rights reserved
 */

#ifndef IMAGEBUF_H_
#define IMAGEBUF_H_

#include "lcdc.h"

#define MAX_BUFFER_WIDTH	1024
#define MAX_BUFFER_HEIGHT	768

#define IMG_GETBITS_NORMAL		0x0000
#define IMG_GETBITS_READONLY	0x0001

typedef void* HIMAGEBUF;

/* 初期化関連 */
HIMAGEBUF IMG_CreateOffscreenBuffer(void);
HIMAGEBUF IMG_CreateBuffer(short width, short height);
void IMG_DeleteBuffer(HIMAGEBUF hBuffer);

/* 表示関連 */
void IMG_TransferToScreen(HIMAGEBUF hBuffer);
void IMG_BitBltToScreen(HIMAGEBUF hBuffer, short x1, short y1, short width, short height, short src, short srcy);

/* 描画関連 */
int IMG_LoadBMP(HIMAGEBUF hBuffer, const char *filename);
void IMG_Fill(HIMAGEBUF hBuffer, unsigned char r, unsigned char g, unsigned char b);
void IMG_BoxFill(HIMAGEBUF hBuffer, short x1, short y1, short x2, short y2, unsigned char r, unsigned char g, unsigned char b);
void IMG_BitBlt(HIMAGEBUF hBuffer, short x, short y, short width, short height, HIMAGEBUF hBufferSrc, short srcx, short srcy);
void IMG_HLine(HIMAGEBUF hBuffer, short x1, short y1, short x2, unsigned char r, unsigned char g, unsigned char b);
void IMG_VLine(HIMAGEBUF hBuffer, short x1, short y1, short y2, unsigned char r, unsigned char g, unsigned char b);
void IMG_Rectangle(HIMAGEBUF hBuffer, short x1, short y1, short x2, short y2, unsigned char r, unsigned char g, unsigned char b);
void IMG_Line(HIMAGEBUF hBuffer, short x1, short y1, short x2, short y2, unsigned char r, unsigned char g, unsigned char b);
void IMG_Circle(HIMAGEBUF hBuffer, short cx, short cy, short rn, unsigned char r, unsigned char g, unsigned char b);
void IMG_CircleFill(HIMAGEBUF hBuffer, short cx, short cy, short rn, unsigned char r, unsigned char g, unsigned char b);
void IMG_SetPixel(HIMAGEBUF hBuffer, short x1, short y1, unsigned char r, unsigned char g, unsigned char b);
void IMG_GetPixel(HIMAGEBUF hBuffer, short x1, short y1, unsigned char *pr, unsigned char *pg, unsigned char *pb);
void IMG_DrawFont(HIMAGEBUF hBuffer, short x1, short y1, short xmag, short ymag, unsigned char code, unsigned char r, unsigned char g, unsigned char b);
void IMG_DrawString(HIMAGEBUF hBuffer, short x1, short y1, short xmag, short ymag, char *pstring, unsigned char r, unsigned char g, unsigned char b);
void IMG_Scroll(HIMAGEBUF hBuffer, short h, short v);
unsigned char* IMG_GetBits(HIMAGEBUF hBuffer, unsigned short option);

/* 情報取得 */
unsigned short IMG_GetWidth(HIMAGEBUF hBuffer);
unsigned short IMG_GetHeight(HIMAGEBUF hBuffer);
unsigned short IMG_GetBitsPerPixel(HIMAGEBUF hBuffer);

#endif /* IMAGEBUF_H_ */
