/*
 * lcdtest.c
 *
 *  Created on: 2013/04/24
 *      Author: r_yokomizu
 */

#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <string.h>
#include "lcdc.h"
#include "imagebuf.h"

static unsigned long next = 1;
int myrand(void)  /* RAND_MAX assumed to be 32767. */
{
    next = next * 1103515245 + 12345;
    return((unsigned)(next/65536) % 32768);
}

int main(int argc, char *pargv[])
{
	int err = 0;
	int wait = 3000, count, count2;
	HIMAGEBUF hBufferD = NULL, hBuffer0 = NULL, hBuffer1 = NULL, hBuffer2 = NULL, hBuffer3 = NULL;
	short x1, y1, x2, y2, r, g, b, rn, code;

	/* LCDC̏ */
	LCDC_Init(LCDC_MODE_RGB565);

	/* 炩߃rbgC[Wǂݍł */
	hBufferD = IMG_CreateBuffer(256,43);
	err = IMG_LoadBMP(hBufferD, "dorixw.bmp");

	if (err == 0) {
		hBuffer1 = IMG_CreateOffscreenBuffer();
		err = IMG_LoadBMP(hBuffer1, "tahichi1.bmp");
		if (err == 0) {
			printf(".");
		}
	}

	if (err == 0) {
		hBuffer2 = IMG_CreateOffscreenBuffer();
		err = IMG_LoadBMP(hBuffer2, "tahichi2.bmp");
		if (err == 0) {
			printf(".");
		}
	}

	if (err == 0) {
		while(1) {
			/* Scene1: AsNZ`i50j */
			LCDC_ClearScreen();
			usleep(100000);
			for(count = 0; count < 500000; count++) {
				x1 = myrand() % 480;
				y1 = myrand() % 272;
				r = myrand() % 255;
				g = myrand() % 255;
				b = myrand() % 255;
				LCDC_SetPixel(x1, y1, r, g, b);
			}

			/* Scene2-1: XN[ */
			r = g = b = 0;
			for(count = 0; count < 272*6; count+=4) {
				if (count % 8 == 0) {
					r = myrand() % 255;
					g = myrand() % 255;
					b = myrand() % 255;
				}
				LCDC_BoxFill(0, 268, 479, 271, r, g, b);
				LCDC_WaitVdisp();
				LCDC_Scroll(0, 4);
			}

			/* Scene2-2: XN[ */
			r = g = b = 0;
			for(count = 0; count < 272*6; count+=4) {
				if (count % 8 == 0) {
					r = myrand() % 255;
					g = myrand() % 255;
					b = myrand() % 255;
				}
				LCDC_BoxFill(0, 0, 479, 4, r, g, b);
				LCDC_WaitVdisp();
				LCDC_Scroll(0, -4);
			}

			/* Scene2-3: XN[ */
			r = g = b = 0;
			for(count = 0; count < 480*6; count+=4) {
				if (count % 8 == 0) {
					r = myrand() % 255;
					g = myrand() % 255;
					b = myrand() % 255;
				}
				LCDC_BoxFill(476, 0, 479, 271, r, g, b);
				LCDC_WaitVdisp();
				LCDC_Scroll(4, 0);
			}

			/* Scene2-4: EXN[ */
			r = g = b = 0;
			for(count = 0; count < 480*6; count+=4) {
				if (count % 8 == 0) {
					r = myrand() % 255;
					g = myrand() % 255;
					b = myrand() % 255;
				}
				LCDC_BoxFill(0, 0, 3, 271, r, g, b);
				LCDC_WaitVdisp();
				LCDC_Scroll(-4, 0);
			}

			usleep(500000);
			LCDC_ClearScreen();
			usleep(100000);

			/* Scene3: BitBlteXg */
			LCDC_ClearScreen();
			usleep(100000);
			for(count=0; count < 1000; count++) {
				x1 = myrand() % 480;
				y1 = myrand() % 272;
				IMG_BitBltToScreen(hBufferD, x1, y1, 256,43, 0,0);
			}

			usleep(500000);
			LCDC_ClearScreen();
			usleep(100000);

			/* Scene4: hԂꂽ~ʕ` */
			for(count = 0; count < 300; count++) {
				x1 = myrand() % 480;
				y1 = myrand() % 272;
				rn = myrand() % 100;
				r = myrand() % 255;
				g = myrand() % 255;
				b = myrand() % 255;
				LCDC_CircleFill(x1, y1, rn, r, g, b);
			}

			usleep(500000);
			LCDC_ClearScreen();
			usleep(100000);

			/* Scene5: ~ʕ` */
			for(count = 0; count < 3000; count++) {
				x1 = myrand() % 480;
				y1 = myrand() % 272;
				rn = myrand() % 100;
				r = myrand() % 255;
				g = myrand() % 255;
				b = myrand() % 255;
				LCDC_Circle(x1, y1, rn, r, g, b);
			}

			usleep(500000);
			LCDC_ClearScreen();
			usleep(100000);

			/* Scene6: ` */
			for(count = 0; count < 5000; count++) {
				x1 = myrand() % 480;
				y1 = myrand() % 272;
				x2 = myrand() % 480;
				y2 = myrand() % 272;
				r = myrand() % 255;
				g = myrand() % 255;
				b = myrand() % 255;
				LCDC_Line(x1, y1, x2, y2, r, g, b);
			}

			usleep(500000);
			LCDC_ClearScreen();
			usleep(100000);

			/* Scene7: `` */
			for(count = 0; count < 3000; count++) {
				x1 = myrand() % 480;
				y1 = myrand() % 272;
				x2 = myrand() % 480;
				y2 = myrand() % 272;
				r = myrand() % 255;
				g = myrand() % 255;
				b = myrand() % 255;
				LCDC_Rectangle(x1, y1, x2, y2, r, g, b);
			}

			usleep(500000);
			LCDC_ClearScreen();
			usleep(100000);

			/* Scene8: hԂꂽ`` */
			for(count = 0; count < 3000; count++) {
				x1 = myrand() % 480;
				y1 = myrand() % 272;
				x2 = myrand() % 480;
				y2 = myrand() % 272;
				r = myrand() % 255;
				g = myrand() % 255;
				b = myrand() % 255;
				LCDC_BoxFill(x1, y1, x2, y2, r, g, b);
				usleep(1000);
			}

			usleep(500000);
			LCDC_ClearScreen();
			usleep(100000);

			/* Scene9: `(P{`W{j */
			for (count2 = 1; count2 <= 8; count2++) {
				usleep(500000);
				LCDC_ClearScreen();
				usleep(100000);
				for(count = 0; count < 1000; count++) {
					x1 = myrand() % 480;
					y1 = myrand() % 272;
					code = myrand() % (0x7e - 0x20) + 0x20;
					r = myrand() % 255;
					g = myrand() % 255;
					b = myrand() % 255;
					LCDC_DrawFont(x1, y1, count2, count2, code, r, g, b);
				}
			}

			usleep(500000);
			LCDC_ClearScreen();
			usleep(100000);

			/* Scene10: rbgC[W` */
			LCDC_WaitVdisp();
			IMG_TransferToScreen(hBuffer1);
			if (wait > 0) {
				usleep(wait*1000);
			}

			LCDC_WaitVdisp();
			IMG_TransferToScreen(hBuffer2);
			if (wait > 0) {
				usleep(wait*1000);
			}
		}
	}
	return err;
}
